
#ifndef _MM_NO_IOSTREAM

#include "udbuf.hxx"
#include <deque>
#include <string>


  /** logbuf is a line oriented streambuf which supresses reduntant lines.
   */
  class Logbuf:public downbuf {
    unsigned _cLines;
    std::deque<std::string> _dqsgLines;
    std::string _sgCur;		/* current line under construction */
    typedef std::deque<std::string>::const_iterator It;
    typedef std::deque<std::string>::reverse_iterator Rit;
    It end() { return _dqsgLines.end(); }


    /* established range of history lines */
    class Range {
      typedef std::deque<std::string>::const_iterator It;
      It _pFirst;		
      It _pCur;
      It _pEnd;
      unsigned _cRep;
      unsigned _cMatch;

     public:
      It pCur() { return _pCur; }
      It pFirst() { return _pFirst; }
      unsigned cRep() { return _cRep; }
      unsigned cRep(unsigned c) { return (_cRep=c); }
      unsigned cLines() { return _cMatch; }
      bool isMatched() { return _pCur == _pEnd; }
      void incMatch() { _pCur++; }
      void rewind() { _cMatch=_pCur-_pFirst; _cRep++; _pCur=_pFirst; }

      Range(It pFirst, It pCur, It pEnd):_pFirst(pFirst), _pCur(pCur), _pEnd(pEnd), _cRep(0), _cMatch(0) {}
      Range() {}
      ~Range() {}
    };
    Range _rg; 
    Range *_prg;

    void clrRange() { _prg=0; }
    void setRange(const Range &rg) {
      _rg=rg;
      _prg=&_rg;
    }
    Range *prg() { return _prg; }


    int processLine(const std::string &sg);	/* do the line			*/
    void addLine(const std::string &sg);	/* add line to history buffer	*/
    int logLine(const std::string &sg);
    It find(const std::string &sg);		/* find most recent occurence in history buffer	*/
    int flush();				/* flush buffered or repeated lines */

   public:
    virtual void logPrefix(std::streambuf *psb);
    int put(const char *pch, int c);
    void drain() { processLine(""); }
    Logbuf(std::streambuf *psbDown, int cLines);
    ~Logbuf();
  };

#endif
