#ifndef _DINO_DINOS_HXX_
#define _DINO_DINOS_HXX_

#include <map>
#include <sstream>
#include "umi/umi_task.hxx"
#include "dino/umipro_dino.hxx"

/*
 * Dino Server Components
 *
 * %LEGAL%
 */

namespace INdepDino100 {

  typedef std::map<std::string, std::pair<int,int> > MpSgBi;


  class DinoOpenServerFunc:public Umi::TaskFunc::Func {

    int cnClient() { return 0; }
    int cnRio() { return 1; }
    DinoOpen* pst() { return pDinoOpen(pmd(cnClient())->puc()); }
    const MpSgBi &_mp;
    MpSgBi::const_iterator _ic;

   public:
    int func( int eState ) {
      //std::cerr << "DinoOpenFunc " << std::dec << eState << std::endl;
      switch (eState) {
	case 0: {		/* init */
	  return setup(10, fCanget(cnClient()));
	} break;

	case 10: {
	    DinoOpen* ptr=pDinoOpen(pmd(cnClient())->puc()); 
	    assert(ptr);
	    std::stringbuf sb;
	    getbuf(&sb, pmd(cnClient())->pug());
	    _ic=_mp.find(sb.str());
	    //std::cerr << *ptr << " (" << sb.str() << ")" << std::endl; 
	  }

	  return setup(70, fCanput(cnClient()));
	case 70: 
	  /* write data rp */
	  DinoOpenResp*prp;
	  prp=new(pmu(cnClient())->puc()) DinoOpenResp();
	  if (_ic!=_mp.end()) {
	    //std::cerr << _ic->first << " " << _ic->second.first << " " << _ic->second.second << std::endl;
	    prp->iByte(_ic->second.first);
	    prp->fBit(_ic->second.second);
	  }
	  return setup(-1, 0, fReleasedown(cnClient())+fSendup(cnClient()));
	default: assert(0);
      }
      return 0;
    }
    DinoOpenServerFunc(const MpSgBi &mp):_mp(mp), _ic(mp.end()) { }
    ~DinoOpenServerFunc() { }
  };

}

#endif

