
/**
 * \file 
 * Dino Multiplexer
 */
#ifndef _DINO_MUX_HXX__
#define _DINO_MUX_HXX__

#include <map>
#include <utility>
#include "umi/umi_task.hxx"
#include "rio/sio.hxx"
#include "dino/dino.hxx"
#include "dio/ports.hxx"


/**
 * namespace defining support for physical devices
 */
namespace INdepDev100 {		
  namespace Umi=INdepUmi100;
  namespace Sio=INdepSio100;
  namespace Dino=INdepDino100;

  const Dino::Dino_dino_Proto theDino_dino_Proto ;


  /**
   * DIO-3460 Physical Device Manager
   */
  class DioMux:public Failables , public Umi::PortMux {

    void sendRequest();		
    void sendResponse(int h);		

   private:
    enum { ceDinoUser, ccPortTypes };
    class DinoSyncServerFunc;

    typedef std::map<std::string, std::pair<int,int> > MpSgBi;
    const MpSgBi mp;

    static PortClass mpPortClass[ccPortTypes+1];

    /* server ports */
    Port _mpPo[ccPortTypes];

    /**
     * create task at port
     */
    Umi::Task *createTask(Umi::Channel *, const PortClass *, Umi::Pmd pmd, Umi::PortMux *pma, int h);
    void deleteTask(const PortClass*, Umi::Task *pta);
  public:

    DioMux( Umi::Channel *pucDrv );
    ~DioMux();
  };
}


#endif
