#ifndef _TINA_TIC_HXX
#define _TINA_TIC_HXX

#include "umic/umi.hxx"
#include "umi/umi_user.hxx"
#include "tina/tina.hxx"
#include "rio/rio.hxx"

/**
 * \file 
 * Tina Client
 */

namespace INdepDev100 {
  namespace Umi=INdepUmi100 ;
  namespace Rio=INdepRio100 ;
  namespace Tina=INdepTina100 ;

  class TicArmClientFunc:public Umi::TaskFunc::Func {
    int _cnRio;
    int _fUnit;

    int cnRio() { return _cnRio; }

   public:
    int func( int eState );
    TicArmClientFunc(int cnRio, int fUnit):_cnRio(cnRio), _fUnit(fUnit) { }
    ~TicArmClientFunc() { }
  };

  class TicConfigClientFunc:public Umi::TaskFunc::Func {
    int _cnRio;

    int cnRio() { return _cnRio; }

   public:
    int func( int eState ) ;
    TicConfigClientFunc(int cnRio):_cnRio(cnRio) { }
    ~TicConfigClientFunc() { }
  };

  class TicMode:public Failable { };

  class TicPlex:public Umi::TaskPlex,  public Failable {
    Umi::ChanUser *_pucIo;
    Umi::Channel *_puc;

    bool _fRun;

    void done(Umi::Task *pta) { 	/* TaskUser virtual */
      _fRun=0; 
    }

    void run(Umi::TaskFunc::Func *ptf) {
      assert(!_fRun); 
      _fRun=1; 

      TaskFunc::run(ptf);
      sigUp(0, _puc, 0);
      runio(_pucIo); 
      assert(!_fRun); 
    }

   public:

    int callTicConfig(TicMode *ptm) { 
      TicConfigClientFunc *ptf=new TicConfigClientFunc(0);	/* deleted by task code ! */
      run(ptf);
      return ptm->isGood();
    }

    int callTicArm() { 
      TicArmClientFunc *ptf=new TicArmClientFunc(0, 3);	/* deleted by task code ! */
      run(ptf);
      return 1;
    }

    
    TicPlex(Umi::Channel *puc, Umi::ChanUser *pucIo):Umi::TaskPlex(puc), 
      _pucIo(pucIo), 
      _puc(puc), 
      _fRun(false)
    {
      assert(*(pucIo->pup()) == INdepRio100::theRio_rio_Proto); 
      assert(*(puc->pup()) == INdepRio100::theRio_rio_Proto); 
    }
  };
}
#endif

