#!/bin/sh
#
# udev RUN script for ines "irio" device class
#
# environment variables:
#  SUBSYSTEM the Umi controlled device class
#  MINOR device instance (kernel slot)
#
# /dev path layout:
#  /dev/<subsystem>/<instance>/<driver>/<channel>



INSTANCE=${1:-$MINOR}
DIR=/dev/$SUBSYSTEM/$INSTANCE

# adjust minor number
CARD=$(($MINOR<<4))

case "$ACTION" in
    add)

      mkdir -p $DIR/rio
      mkdir -p $DIR/aes
      mkdir -p $DIR/gdi
      mkdir -p $DIR/gti
      mknod $DIR/rio/0 c $MAJOR $(($CARD+0))
      mknod $DIR/aes/0 c $MAJOR $(($CARD+0))
      mknod $DIR/rio/1 c $MAJOR $(($CARD+1))
      mknod $DIR/gdi/0 c $MAJOR $(($CARD+4))
      mknod $DIR/gti/0 c $MAJOR $(($CARD+8))
      chmod 0666 $DIR/*/*
    ;;
    remove)
      rm -r $DIR
    ;;
esac


