
/*
 *
 */

#include <linux/init.h>
#include <linux/types.h>
#include <linux/module.h>
#include <linux/moduleparam.h>
#include <linux/pci.h>
#include <linux/isa.h>
#include <linux/usb.h>
#include <linux/version.h>
#include "mod.h"
#include "version.h"
#include "rioc/sioc.h"

int _GLOBAL_OFFSET_TABLE_;

/*
 * declare the license of this module
 */
MODULE_LICENSE("GPL");


  struct LumiModStruct dm ;		/* forward declaration */

  /* table of devices that work with this driver */
  static struct usb_device_id mpUdi [] = {
    { USB_DEVICE(0x04b4, 0x3460), .driver_info=(kernel_ulong_t)&adUsbSio },
    { USB_DEVICE(0x04b4, 0x7833), .driver_info=(kernel_ulong_t)&adUsbPam },
    { }                                     /* Terminating entry */
  };

  /*
   * announce our capabilities 
   *
   * that's why we need the static xxx_device_id tables
   * in the wrapper module
   */
  MODULE_DEVICE_TABLE(usb, mpUdi);

  int fDebug=0;
  static int cIsa;
  static struct usb_driver udr;

  module_param(fDebug, int, 0);




  int sioopen(struct inode * pin, struct file *fp) { return umi_open(&dm, pin, fp); }

  static struct file_operations sio_fops=
  {
    owner: THIS_MODULE, 
    open: sioopen,
    release: umi_release,
    poll: umi_poll,
    unlocked_ioctl: umi_unlocked_ioctl,
  };

  struct LumiModStruct dm = {
    "isio",
    "ines Sio Protocol",
    VERSION_STRING ,
    &umSio,
    &fDebug,
    &sio_fops,
    0,
    0,
    0,
    0,
    mppadSio,
    0, &cIsa,
    0,
    &udr,
    "driver/isio"
  };

  int usb_probe(struct usb_interface *pui, const struct usb_device_id *pdi) { return pdm_usb_probe(&dm, pui, pdi); }
  void usb_disconnect(struct usb_interface *pui) { return pdm_usb_disconnect(&dm, pui); }
  
  static struct usb_driver udr = {
   #if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,16)
    .owner = THIS_MODULE,
   #endif
    .name= 	"isio",
    .probe= 	usb_probe,
    .disconnect=  usb_disconnect,
    .id_table=	mpUdi
  };


  static int init_sio (void) { return pdm_init_module(&dm); }
  static void cleanup_sio (void) { return pdm_cleanup_module(&dm); }

  module_init(init_sio);
  module_exit(cleanup_sio);

