#include "sizes.h"
#include "card.h"
#include "assert.h"
#include <linux/string.h>


  void pcn_init(Chan *pcn, Card *pca, const struct UmiDriverDesc *pUdd, int iChanOfDriver, int iChanOfCard, int iDriverOfCard) {
    pcn->_flag=0; 
    pcn->_pca=pca; 
    pcn->_pUdd=pUdd; 
    pcn->_iChanOfDriver=iChanOfDriver;
    pcn->_iChanOfCard=iChanOfCard;
    pcn->_iDriverOfCard=iDriverOfCard;
    pcn->_szStat="";
    spin_lock_init(&(pcn)->_slAcc);
    init_waitqueue_head(&(pcn->_wqAcc));
  }

  void pca_init(Card *pca, struct LumiModStruct *pdm) {
    int iDriver;
    memset(pca, 0, sizeof(*pca));
    pca->_pdm=pdm;
    pca->_iDriver=-1;
    pca->_fState=SCA_IDLE;
    spin_lock_init(&(pca)->_sl);

    for (iDriver=0; iDriver<UmiMod_getDriverCount(pdm->_pum); iDriver++) {
      const struct UmiDriverDesc *pUdd=UmiMod_getDriverDesc(pdm->_pum, iDriver);
      int iChanOfDriver;
      assert(pUdd);
      for (iChanOfDriver=0; iChanOfDriver<UmiDriverDesc_getChanCount(pUdd); iChanOfDriver++) {
	int iChanOfCard=(iDriver*MAX_DRCN)+iChanOfDriver;
	Chan *pcn=pca->_mpcn+iChanOfCard;
	printk(KERN_DEBUG PFX "card: new chan %td %s %d\n", pdm->_szDid, pcn-pca->_mpcn, UmiProto_szName(pUdd->_pup), iChanOfDriver);
	pcn_init(pcn, pca, pUdd, iChanOfDriver, iChanOfCard, iDriver);
      }
    }
  }
