set -e

#
# assign variables
#
getarch() {
  ARCH=$(uname -i)
  [ "$ARCH" = "unknown" ] && ARCH=$(uname -m) 
  case $ARCH in
    i386) ISA=x86$1; CCS=gcc3 ;;
    i686) ISA=x86$1; CCS=gcc4 ;;
    x86_64) ISA=a64; CCS=gcc4 ;;
  esac

  case $(gcc -v 2>&1) in
    *4.[1-5].*) CCS=gcc4 ;;
    *4.[6-8].*) CCS=gcc46 ;;
    *5.4.*) CCS=gcc46 ;;
    *7.[23].*) CCS=gcc7 ;;
  esac

  [ -z "$ISA" ] && { echo "unsupported architecture ($ARCH), please contact support@inesinc.com"; exit; }
  [ -n "$IDREP" ] && LIB_DIR=$IDREP/lkern_${ISA}_${CCS}/lib || LIB_DIR=$PWD/../../arch/lkern_${ISA}_${CCS}/lib
}

. ./modsetup.sh


#
# first pass
#
getarch 
set +e
make  -C /lib/modules/$(uname -r)/build SUBDIRS=$PWD MOD_INCLUDES="$MOD_INCLUDES" MOD_LIB_DIR=$LIB_DIR MOD_LIBS="$MOD_LIBS" EXTRA_SYMBOLS="$EXTRA_SYMBOLS" modules 
set -e

#
# optional second pass
# for kernels compile with -mregparm=[123]
#
fgrep -q "regparm=3" .$REFMOD.o.cmd && {
  rm -f *.o *.ko $REFMOD.mod.c
  getarch rp3
  echo $LIB_DIR
  make  -C /lib/modules/$(uname -r)/build SUBDIRS=$PWD MOD_INCLUDES="$MOD_INCLUDES" MOD_LIB_DIR=$LIB_DIR MOD_LIBS="$MOD_LIBS" EXTRA_SYMBOLS="$EXTRA_SYMBOLS" modules 
  exit 
}
grep -q -e "regparm=[12]" .$REFMOD.o.cmd && { echo "Kernel not supported, contact support@inesinc.com"; exit 2; }

exit 0
